#!/usr/bin/env python

import sys

input_fname, id_col, mapping_fname, output_fname = sys.argv[1:]

id_col = int( id_col )

def field_iter( fname ):
    """
    Iterate a tab separated file
    """
    for line in open( fname ):
        if line.startswith( "#" ):
            continue
        yield line.strip( "\r\n" ).split( "\t" )

# Read mapping from first two columns of mapping_fname
id_map = {}
for fields in field_iter( mapping_fname ):
    id_map[ fields[0] ] = fields[1]

# Open output for write
out = open( output_fname, "w" )

# Read input, attempt to translate ID, and write output
for fields in field_iter( input_fname ):
    if id_col >= len( fields ):
        # Ignoring short lines
        continue
    old_id = fields[ id_col ]
    if old_id in id_map:
        fields[ id_col ] = id_mapping[ old_id ]
    # Write to output
    print >> out, "\t".join( fields )
